function class(base, init)
   local c = {}    -- a new class instance
   if not init and type(base) == 'function' then
      init = base
      base = nil
   elseif type(base) == 'table' then
      for i,v in pairs(base) do
         c[i] = v
      end
      c._base = base
   end
   c.__index = c
   local mt = {}
   mt.__call = function(class_tbl, ...)
   local obj = {}
   setmetatable(obj,c)
   if init then
      init(obj,...)
   else 
      if base and base.init then
      base.init(obj, ...)
      end
   end
   return obj
   end
   c.init = init
   c.is_a = function(self, klass)
      local m = getmetatable(self)
      while m do 
         if m == klass then return true end
         m = m._base
      end
      return false
   end
   setmetatable(c, mt)
   return c
end

obj_6679_count_food = class()
function obj_6679_count_food:state(state)
  	function statecount()--this function counts the number of some items--
    		print ("state count called")
        local summ=0
        summ = summ + viewer.getOptParamI("food.ice_cream",0)
        summ = summ + viewer.getOptParamI("food.cheese",0)
        summ = summ + viewer.getOptParamI("food.chips_fruit",0)
        summ = summ + viewer.getOptParamI("food.fruit_salad",0)
        summ = summ + viewer.getOptParamI("food.grilled_salmon",0)
        summ = summ + viewer.getOptParamI("food.hot_dog",0)
        summ = summ + viewer.getOptParamI("food.rolls",0)
        summ = summ + viewer.getOptParamI("food.shrimp",0)
        summ = summ + viewer.getOptParamI("food.steak_beef",0)
        summ = summ + viewer.getOptParamI("food.water_melon",0)
        summ = summ + viewer.getOptParamI("energy.all_100",0)
        summ = summ + viewer.getOptParamI("energy.liveliness_100",0)
        summ = summ + viewer.getOptParamI("energy.satiety_0",0)
        summ = summ + viewer.getOptParamI("energy.xp_potion_2",0)
        summ = summ + viewer.getOptParamI("food.bamboo",0)
        summ = summ + viewer.getOptParamI("food.bamboo_worms",0)
        summ = summ + viewer.getOptParamI("food.corn",0)
        summ = summ + viewer.getOptParamI("food.dandelion_salad",0)
        summ = summ + viewer.getOptParamI("food.eucalyptus",0)
        summ = summ + viewer.getOptParamI("food.laminaria",0)
        summ = summ + viewer.getOptParamI("food.nuts",0)
        summ = summ + viewer.getOptParamI("food.banana",0)
        summ = summ + viewer.getOptParamI("food.cereals",0)
        summ = summ + viewer.getOptParamI("food.broccoli",0)
        summ = summ + viewer.getOptParamI("food.jelly",0)
        summ = summ + viewer.getOptParamI("food.honey",0)
        summ = summ + viewer.getOptParamI("food.barbecue",0)
        summ = summ + viewer.getOptParamI("food.battery",0)
        summ = summ + viewer.getOptParamI("food.bolts",0)
        summ = summ + viewer.getOptParamI("food.energoapple",0)
        summ = summ + viewer.getOptParamI("food.lamp",0)
        summ = summ + viewer.getOptParamI("food.metalbone",0)
        summ = summ + viewer.getOptParamI("food.oil",0)
        summ = summ + viewer.getOptParamI("food.robobanana",0)
        summ = summ + viewer.getOptParamI("food.robosteak",0)
        summ = summ + viewer.getOptParamI("food.robobarbecue",0)
        viewer.setObjParamI(6664,"stock_quantity",summ)
        print(("Сумма предметов еды и энергетиков: %d"):format(summ))
    end
    print("This function starts when object changes state")
	if 	(state == "count") then
		statecount()
	end
end

obj_add_item = class()
function obj_add_item:state(state,guestID)
  function get_items_table()
  items={
    {name="ice_cream",        value=viewer.getOptParamI("food.ice_cream",0),        ID=1190},
    {name="cheese",           value=viewer.getOptParamI("food.cheese",0),           ID=1200},
    {name="chips_fruit",      value=viewer.getOptParamI("food.chips_fruit",0),      ID=1203},
    {name="fruit_salad",      value=viewer.getOptParamI("food.fruit_salad",0),      ID=1206},
    {name="grilled_salmon",   value=viewer.getOptParamI("food.grilled_salmon",0),   ID=1209},
    {name="hot_dog",          value=viewer.getOptParamI("food.hot_dog",0),          ID=1212},
    {name="rolls",            value=viewer.getOptParamI("food.rolls",0),            ID=1215},
    {name="shrimp",           value=viewer.getOptParamI("food.shrimp",0),           ID=1218},
    {name="steak_beef",       value=viewer.getOptParamI("food.steak_beef",0),       ID=1221},
    {name="water_melon",      value=viewer.getOptParamI("food.water_melon",0),      ID=1224},
    {name="apple_j",          value=viewer.getOptParamI("drink.apple_j",0),         ID=1254},
    {name="banana_milk",      value=viewer.getOptParamI("drink.banana_milk",0),     ID=1262},
    {name="choco_milk",       value=viewer.getOptParamI("drink.choco_milk",0),      ID=1266},
    {name="grapefruit_j",     value=viewer.getOptParamI("drink.grapefruit_j",0),    ID=1310},
    {name="milk",             value=viewer.getOptParamI("drink.milk",0),            ID=1270},
    {name="mojito",           value=viewer.getOptParamI("drink.mojito",0),          ID=1274},
    {name="mulled_wine",      value=viewer.getOptParamI("drink.mulled_wine",0),     ID=1278},
    {name="orange_j",         value=viewer.getOptParamI("drink.orange_j",0),        ID=1282},
    {name="pina_colada",      value=viewer.getOptParamI("drink.pina_colada",0),     ID=1286},
    {name="soda",             value=viewer.getOptParamI("drink.soda",0),            ID=1290},
    {name="strawberry_j",     value=viewer.getOptParamI("drink.strawberry_j",0),    ID=1294},
    {name="tomato_j",         value=viewer.getOptParamI("drink.tomato_j",0),        ID=1298},
    {name="water_melon_j",    value=viewer.getOptParamI("drink.water_melon_j",0),   ID=1302},
    {name="whisky",           value=viewer.getOptParamI("drink.whisky",0),          ID=1306},
    {name="all_100",          value=viewer.getOptParamI("energy.all_100",0),        ID=1634},
    {name="liveliness_100",   value=viewer.getOptParamI("energy.liveliness_100",0), ID=1638},
    {name="satiety_0",        value=viewer.getOptParamI("energy.satiety_0",0),      ID=1642},
    {name="xp_potion_2",      value=viewer.getOptParamI("energy.xp_potion_2",0),    ID=1647},
    {name="water",            value=viewer.getOptParamI("drink.water",0),           ID=2394},
    {name="bamboo",           value=viewer.getOptParamI("food.bamboo",0),           ID=2399},
    {name="bamboo_worms",     value=viewer.getOptParamI("food.bamboo_worms",0),     ID=2403},
    {name="corn",             value=viewer.getOptParamI("food.corn",0),             ID=2407},
    {name="dandelion_salad",  value=viewer.getOptParamI("food.dandelion_salad",0),  ID=2411},
    {name="eucalyptus",       value=viewer.getOptParamI("food.eucalyptus",0),       ID=2415},
    {name="bamboo_tut",       value=viewer.getOptParamI("food.bamboo_tut",0),       ID=2426},
    {name="laminaria",        value=viewer.getOptParamI("food.laminaria",0),        ID=2419},
    {name="nuts",             value=viewer.getOptParamI("food.nuts",0),             ID=2545},
    {name="banana",           value=viewer.getOptParamI("food.banana",0),           ID=2549},
    {name="cereals",          value=viewer.getOptParamI("food.cereals",0),          ID=2553},
    {name="broccoli",         value=viewer.getOptParamI("food.broccoli",0),         ID=2557},
    {name="jelly",            value=viewer.getOptParamI("food.jelly",0),            ID=2561},
    {name="honey",            value=viewer.getOptParamI("food.honey",0),            ID=2565},
    {name="barbecue",         value=viewer.getOptParamI("food.barbecue",0),         ID=2569},
    {name="battery",          value=viewer.getOptParamI("food.battery",0),          ID=4506},
    {name="bolts",            value=viewer.getOptParamI("food.bolts",0),            ID=4510},
    {name="energoapple",      value=viewer.getOptParamI("food.energoapple",0),      ID=4514},
    {name="lamp",             value=viewer.getOptParamI("food.lamp",0),             ID=4518},
    {name="metalbone",        value=viewer.getOptParamI("food.metalbone",0),        ID=4522},
    {name="oil",              value=viewer.getOptParamI("food.oil",0),              ID=4526},
    {name="robobanana",       value=viewer.getOptParamI("food.robobanana",0),       ID=4530},
    {name="clown",            value=viewer.getOptParamI("vip.clown",0),             ID=5016},
    {name="drakula",          value=viewer.getOptParamI("vip.drakula",0),           ID=5012},
    {name="elvis",            value=viewer.getOptParamI("vip.elvis",0),             ID=5020},
    {name="glass",            value=viewer.getOptParamI("vip.glass",0),             ID=5024},
    {name="dance",            value=viewer.getOptParamI("vip.dance",0),             ID=5044},
    {name="lense_evil1",      value=viewer.getOptParamI("vip.lense_evil1",0),       ID=5036},
    {name="lense_evil2",      value=viewer.getOptParamI("vip.lense_evil2",0),       ID=5040},
    {name="lense_kind1",      value=viewer.getOptParamI("vip.lense_kind1",0),       ID=5028},
    {name="lense_kind2",      value=viewer.getOptParamI("vip.lense_kind2",0),       ID=5032},
    {name="puk",              value=viewer.getOptParamI("vip.puk",0),               ID=5048},
    {name="robosteak",        value=viewer.getOptParamI("food.robosteak",0),        ID=9048},
    {name="robobarbecue",     value=viewer.getOptParamI("food.robobarbecue",0),     ID=9052},
    {name="bubble_gum",       value=viewer.getOptParamI("vip.bubble_gum",0),        ID=9194},
  }
  end
  function sort_items()
    table.sort(items, function(a,b) return (a.value>b.value) end)
      print("Таблица с спредметами отсортирована по убыванию")
  end
	function add_items()
    		print ("state check called")
        for i=1,table_length(items) do
          if (items[i].value > 0) then
            viewer.changeObjState(items[i].ID,"forced_add")
            print ("В холодильник добавлен: "..items[i].name)
          end
        end
  end
  	
	if 	(state == "check") then
    get_items_table()
    sort_items()
		add_items()
  end
end

obj_big_win_text = class()
function obj_big_win_text:state(state,guestID)
  	function init() -- попадание в состояние init
    		print ("state init called")
        self.start_t=os.time()
  	end
    function animation() -- попадание в состояние animation
    		print ("state animation called")
        self.end_t=os.time()
        viewer.setObjParamI(6664,"game_time",self.end_t-self.start_t)
   	end
  	print("This function starts when object changes state with object id who change this state")
	if 	(state == "init") then
		init()
	end
  if 	(state == "animation") then
		animation()
	end
end

obj_buy_recipe_win = class()
function obj_buy_recipe_win:state(state,guestID)
  	function try_buy_items()
        animal_id = viewer.getObjParamI(1614,"txtID",0)
    		print (string.format("Открыли окно с покупкой предметов для животного: %d",animal_id))
        buy_recipe_t = viewer.getOptParamI("stat.animal_buy_recipe.animal_"..animal_id,0,0)
        time = os.time()-buy_recipe_t
        time = math.log(time)
        time = math.floor(time*24)
        viewer.setObjParamI(7866,"t_recipe",time)
  	end
  	
	if 	(state == "open_items_") then
		try_buy_items()
	end
end

obj_check_buy_recipe = class()
function obj_check_buy_recipe:state(state,guestID)
  	function set_log_t()
        animal_id = viewer.getObjParamI(1614,"txtID",0)
        viewer.setOptParamI("stat.animal_buy_recipe.animal_"..animal_id,os.time(),0)
    		--print(string.format("Время покупки рецепта животного: %d = %d",animal_id,os.time()))
  	end
  	
	if 	(state == "buy") then
		set_log_t()
	end
end

obj_check_buy_recipe_items = class()
function obj_check_buy_recipe_items:state(state,guestID)
  	function buy_items()
    		animal_id = viewer.getObjParamI(1614,"txtID",0)
    		print (string.format("Купили предметы для животного: %d",animal_id))
        buy_recipe_t = viewer.getOptParamI("stat.animal_buy_recipe.animal_"..animal_id,0,0)
        time = os.time()-buy_recipe_t
        time = math.log(time)
        time = math.floor(time*24)
        viewer.setObjParamI(7866,"t_recipe",time)
  	end
  	
	if 	(state == "buy") then
		buy_items()
	end
end

obj_check_generate = class()
function obj_check_generate:state(state,guestID)
  	function check()
    		get_table_animals()
        local count_duplicate = 0
        for i=1,table_length(animals) do
          if (animals[i].value > 1) then
            count_duplicate = count_duplicate + animals[i].value - 1
          end
        end  
          if (count_duplicate > 1) then
            viewer.setOptParamI("action.count_duplicate",count_duplicate,0)
            generate_animals()
          end                    
  	end
    function generate_animals()
      animals_generated={}
      table.sort(animals, function(a,b) return (a.price<b.price) end)
      local n=1
      for i=1,table_length(animals) do
        if ((animals[i].value==0)and(viewer.getOptParamI("eitems1154.i"..animals[i].receip_id,0,1)==0)) then -- 
          print("Рецепт животного "..animals[i].an_id.." в таблице с номером "..i)
          animals_generated[n]=i
          n = n+1
        end
      end  
      if (table_length(animals_generated)>2) then
        for i=1,3 do
          print ("action.diet_ids.id"..i,animals[animals_generated[i]].receip_id)
          viewer.setOptParamI("action.diet_ids.id"..i,animals[animals_generated[i]].receip_id,1)                    
        end
        print ("Забираем айли картинок из текстовых ресурсов животных")
        res1 = viewer.getResFromTxtDB(animals[animals_generated[1]].an_id,1,4027)
        res2 = viewer.getResFromTxtDB(animals[animals_generated[2]].an_id,1,4027)
        res3 = viewer.getResFromTxtDB(animals[animals_generated[3]].an_id,1,4027)
        viewer.setObjParamI(8354,"res",res1)
        viewer.setObjParamI(8355,"res",res2)
        viewer.setObjParamI(8356,"res",res3)
        viewer.changeObjState(8354,"init")
        viewer.changeObjState(8355,"init")
        viewer.changeObjState(8356,"init")
      else 
        local id_sc = viewer.getObjParamI(8332,"id_sc",1207)
        viewer.setObjParamI(2694,"param",id_sc)
        viewer.changeObjState(2694,"ok")
        viewer.changeObjState(2694,"check_multiple")
        viewer.setOptParamI("action.right_diet_full",1,1)
      end
    end
  	
	if 	(state == "check") then
		check()
	end
end

obj_common_calc_money = class()
function obj_common_calc_money:init()
    local tend = os.time()
    local tstart = os.time()
    viewer.setObjParamI(8378,"tend",tend)
    viewer.setObjParamI(8378,"tstart",tstart)
    print("tstart="..tstart.." tend="..tend)
end
function obj_common_calc_money:state(state,guestID)
  	function calc()
        local score = viewer.getOptParamI("mg.score",0,0)
        local satiety = tonumber(satiety())
        local gold_x2 = viewer.getOptParamI("store.x2_forever_was",0,0)
        local gold_gift = viewer.getOptParamF("gold_coef",1,0) - gold_x2 - 1
        local coins_score = math.floor(tonumber(score_coins(score)))
        local coins_satiety = math.floor(tonumber(score_coins(score)*satiety))
        local coins_gift = math.floor(tonumber(score_coins(score)*gold_gift))
        local coins_x2 = math.floor(tonumber(score_coins(score)*gold_x2))
        local coins_chest = viewer.getObjParamI(3554,"user_rewards",0)
        local coins_total = math.floor(tonumber(coins_score + coins_satiety + coins_gift + coins_x2 + coins_chest))
        local xp_total = math.floor(coins_total/10)
        viewer.setObjParamS(8378,"coins_score",coins_score)
        viewer.setObjParamS(8378,"coins_satiety",coins_satiety)
        viewer.setObjParamS(8378,"coins_gift",coins_gift)
        viewer.setObjParamS(8378,"coins_x2",coins_x2)
        viewer.setObjParamS(8378,"coins_chest",coins_chest)
        viewer.setObjParamS(8378,"coins_total",coins_total)
        viewer.setObjParamS(8378,"xp_total",xp_total)
        viewer.changeObjState(10276,"init")
        if (satiety == 0) then
            viewer.changeObjState(10332,"disable")
        else viewer.changeObjState(10332,"enable")
        end 
        if (gold_x2 == 0) then
            viewer.changeObjState(10330,"disable")
        else viewer.changeObjState(10330,"enable")
        end
        if (gold_gift == 0) then
            viewer.changeObjState(10331,"disable")
        else viewer.changeObjState(10331,"enable")
        end
        if (coins_chest == 0) then
          local prevScrID = viewer.getOptParamI("prevScrID",0,0)
            if (prevScrID == 8982 or prevScrID == 6015 or prevScrID == 8832 or prevScrID == 6288 or prevScrID == 1417
                    or prevScrID == 5914 or prevScrID == 10712 or prevScrID == 10769 or prevScrID == 10982
                    or prevScrID == 11101 or prevScrID == 11357) then
                viewer.changeObjState(10287,"not_exist")
            else    
            viewer.changeObjState(10287,"disable")
            end
        else viewer.changeObjState(10287,"enable")
        end
  	end
    function satiety()
        local satiety = viewer.getOptParamF("pet685.satiety",0,1)
        local coef = 0
        if (satiety <= 100 and satiety >=50) then
          coef = 1
          return coef
        elseif (satiety <= 50 and satiety >0) then
          coef = 0.5
          return coef
        else return coef
        end
    end  
    function score_coins(score)
        local prevScrID = viewer.getOptParamI("prevScrID",0,0)
        if (prevScrID == 1758 or prevScrID == 1541) then
            local level = viewer.getObjParamI(6664,"last_level_match",0)
            score = score*(level+1)/12
            return score
        elseif (prevScrID == 4973) then
            score = score/12
            return score
        elseif (prevScrID == 1417) then
            score = score*2
            return score
        elseif (prevScrID == 8832) then
            score = score*2
            return score
        elseif (prevScrID == 10712) then
            score = score*8
            return score
        elseif (prevScrID == 10769) then
            score = score*4
            return score
        elseif (prevScrID == 10981) then
            score = score/8
            return score
        elseif (prevScrID == 11101) then
            score = score*6
            return score
        elseif (prevScrID == 11357) then
            score = score*2
            return score
        elseif (prevScrID == 10982) then
            score = score*8
            return score
        elseif (prevScrID == 5914) then
            score = score/3
            return score
        else return score/2
        end
    end
    function game_start()
        print ("state game_start called")
        self.start_t=os.time()
    end
    function game_end()
        self.end_t=os.time()
        viewer.setObjParamI(6664,"time_in_game",self.end_t-self.start_t)
    end
	if 	(state == "calc") then
        calc()
    end
    if 	(state == "start") then
        game_start()
    end
    if 	(state == "end") then
        game_end()
    end
end

obj_first_show_time = class()
function obj_first_show_time:state(state,guestID)
  	function set_show_first_time()
    		local id_scenario = viewer.getObjParamI(8383,"id_sc",0)
        local time = os.time()
        viewer.setOptParamI("stat.actions_views.id"..id_scenario..".t_act",time,0)
  	end
  	function get_show_first_time()
    		local id_scenario = viewer.getObjParamI(2694,"param",0)
        local time_act = viewer.getOptParamI("stat.actions_views.id"..id_scenario..".t_act",0,0)
        time = os.time() - time_act
        time = math.log(time)
        time = math.floor(time*24)       
        viewer.setObjParamI(6664,"first_show_time",time)
  	end
	if 	(state == "set") then
		set_show_first_time()
	end
  if 	(state == "get") then
		get_show_first_time()
	end
end

obj_generate_reward = class()
function obj_generate_reward:state(state,guestID)
  	function generate()
    		local level = viewer.getOptParamI("ecomics6.level",4,1)
        viewer.setOptParamI("action.level_generate_reward_social_task",level,1)
  	end
    function set()
      local res = 0
      local level = viewer.getOptParamI("action.level_generate_reward_social_task",4,1)
    		if (level == 4 | level == 14 | level == 6) then
          res = viewer.getResFromTxtDB(565,1,0)
          viewer.setObjParamI(8729,"res",res)
          viewer.changeObjState(8729,"init")
        end
        if (level == 8) then
          res = viewer.getResFromTxtDB(617,1,0)
          viewer.setObjParamI(8729,"res",res)
          viewer.changeObjState(8729,"init")
          print("reward res: "..res)
        end
        if (level == 3) then
          res = viewer.getResFromTxtDB(617,1,0)
          viewer.setObjParamI(8729,"res",res)
          viewer.changeObjState(8729,"init")
          print("reward res: "..res)
        end 
        if (level == 10) then
          res = viewer.getResFromTxtDB(614,1,0)
          viewer.setObjParamI(8729,"res",res)
          viewer.changeObjState(8729,"init")
        end 
        if (level == 12) then
          res = viewer.getResFromTxtDB(612,1,0)
          viewer.setObjParamI(8729,"res",res)
          viewer.changeObjState(8729,"init")
        end 
  	end
  	
	if 	(state == "generate") then
		generate()
	end
  if 	(state == "set") then
		set()
	end
end

obj_get_bundle_ = class()
function obj_get_bundle_:state(state,guestID)
  	function get_bundle1()
    		local animal_id = viewer.getOptParamS("bundle_animal_id",0,0)
        print("animal_id = "..animal_id)
        if (tonumber(animal_id) ~= 0) then
            print("animal_id != 0")
            local owned = viewer.getOptParamS("pet685.animal_"..animal_id..".owned",0,1)
            viewer.setOptParamS("pet685.animal_"..animal_id..".bonus_generated",0,1)
            viewer.setOptParamS("pet685.animal_"..animal_id..".passef_time_bonus",0,1)
            viewer.setOptParamS("pet685.animal_"..animal_id..".owned",owned+1,1)
            viewer.setOptParamS("pet685.animal_"..animal_id..".id",animal_id,1)
            viewer.setOptParamS("pet685.animal_"..animal_id..".birthday",os.time(),1)
            animal_id = viewer.setOptParamS("bundle_animal_id",0,0)
            viewer.changeObjState(685,"read")
            print("animal added")
        end  
  	end
  	
	if 	(state == "get_bundle1") then
		get_bundle1()
	end
end

obj_info_animal_machine = class()
function obj_info_animal_machine:state(state,guestID)
  	function wnd_load_n()
    		animal_id = viewer.getObjParamI(1614,"txtID",0)
        wnd_load = viewer.getOptParamI("stat.animal_wnd_load.animal_"..animal_id,0,0)
        wnd_load = wnd_load + 1
        viewer.setOptParamI("stat.animal_wnd_load.animal_"..animal_id,wnd_load,0)
        viewer.setObjParamI(1608,"wnd_load_n",wnd_load)
  	end
  	print("Функция вызывается при открытии окна с силуэтом животного")
	if 	(state == "open_with_recipe_") then
		wnd_load_n()
	end
end

obj_mahjong_move = class()
function obj_mahjong_move:state(state,guestID)
  	function beg1()
    		local val = viewer.getObjParamI(4467,"val",0)
        local time1 = viewer.getObjParamS(4467,"time1",0)
        local time2 = os.time()
        local t = time2-time1
        if (t==0) then
          t = 0.5
        end
        local score = 10 + (5/t)
        score = math.floor(score)
        val = val + score
        viewer.setObjParamI(4467,"val",val)
        viewer.setObjParamS(4467,"time1",time2)
  	end
  	
	if 	(state == "beg1") then
		beg1()
	end
end

obj_play_hungry = class()
function obj_play_hungry:state(state,guestID)
  	function start()
    		self.start_t=os.time()
        viewer.setOptParamI("start_t",self.start_t,0)
  	end
    function check()
    		self.cur_t=os.time()
        local start_t = viewer.getOptParamI("start_t",self.cur_t,0)
        viewer.setObjParamI(8378,"time",self.cur_t-start_t)
  	end
  	
	if 	(state == "start") then
		start()
	end
  if 	(state == "check") then
		check()
	end
end

obj_refresh_parse_info = class()
 animals={}--переменная таблицы животных в опциях
 animals_public={}--переменная таблицы животных в паблике
 function get_table_animals ()
      print ("функция создает таблицу животных: имя, количество, ID (машинки, которая будет попадать в таблицу)")
      animals={
        {name='brontosaurus',   value=viewer.getOptParamI("pet685.animal_225.owned",0),   ID=6699,  price=20600,  receip_id=1057, an_id=225},
        {name='camel',          value=viewer.getOptParamI("pet685.animal_143.owned",0),   ID=6702,  price=7050,   receip_id=1032, an_id=143},
        {name='cat',            value=viewer.getOptParamI("pet685.animal_315.owned",0),   ID=6704,  price=11950,  receip_id=1038, an_id=315},
        {name='chameleon',      value=viewer.getOptParamI("pet685.animal_141.owned",0),   ID=6706,  price=25750,  receip_id=1066, an_id=141},
        {name='cow',            value=viewer.getOptParamI("pet685.animal_316.owned",0),   ID=6708,  price=17200,  receip_id=1049, an_id=316},
        {name='crocodile',      value=viewer.getOptParamI("pet685.animal_133.owned",0),   ID=6710,  price=21500,  receip_id=1060, an_id=133},
        {name='deer',           value=viewer.getOptParamI("pet685.animal_238.owned",0),   ID=6712,  price=17700,  receip_id=1052, an_id=238},
        {name='dolphin',        value=viewer.getOptParamI("pet685.animal_227.owned",0),   ID=6714,  price=15000,  receip_id=1044, an_id=227},
        {name='eagle',          value=viewer.getOptParamI("pet685.animal_135.owned",0),   ID=6716,  price=15800,  receip_id=1047, an_id=135},
        {name='elephant',       value=viewer.getOptParamI("pet685.animal_131.owned",0),   ID=6718,  price=7200,   receip_id=1033, an_id=131},
        {name='fish',           value=viewer.getOptParamI("pet685.animal_130.owned",0),   ID=6720,  price=21350,  receip_id=1059, an_id=130},
        {name='fox',            value=viewer.getOptParamI("pet685.animal_228.owned",0),   ID=6722,  price=23500,  receip_id=1062, an_id=228},
        {name='hippo',          value=viewer.getOptParamI("pet685.animal_229.owned",0),   ID=6724,  price=8900,   receip_id=1036, an_id=229},
        {name='horse',          value=viewer.getOptParamI("pet685.animal_230.owned",0),   ID=6726,  price=13950,  receip_id=1042, an_id=230},
        {name='kangaroo',       value=viewer.getOptParamI("pet685.animal_140.owned",0),   ID=6728,  price=13100,  receip_id=1041, an_id=140},
        {name='koala',          value=viewer.getOptParamI("pet685.animal_231.owned",0),   ID=6730,  price=25100,  receip_id=1064, an_id=231},
        {name='lamb',           value=viewer.getOptParamI("pet685.animal_232.owned",0),   ID=6732,  price=16550,  receip_id=1048, an_id=232},
        {name='lion',           value=viewer.getOptParamI("pet685.animal_132.owned",0),   ID=6734,  price=18250,  receip_id=1053, an_id=132},
        {name='ostrich',        value=viewer.getOptParamI("pet685.animal_139.owned",0),   ID=6736,  price=19100,  receip_id=1055, an_id=139},
        {name='owl',            value=viewer.getOptParamI("pet685.animal_138.owned",0),   ID=6738,  price=23650,  receip_id=1063, an_id=138},
        {name='panda',          value=viewer.getOptParamI("pet685.animal_129.owned",0),   ID=6740,  price=6000,   receip_id=1031, an_id=129},
        {name='peacock',        value=viewer.getOptParamI("pet685.animal_136.owned",0),   ID=6742,  price=18250,  receip_id=1054, an_id=136},
        {name='penguin',        value=viewer.getOptParamI("pet685.animal_134.owned",0),   ID=6744,  price=12950,  receip_id=1039, an_id=134},
        {name='polarbear',      value=viewer.getOptParamI("pet685.animal_233.owned",0),   ID=6746,  price=17500,  receip_id=1051, an_id=233},
        {name='shark',          value=viewer.getOptParamI("pet685.animal_144.owned",0),   ID=6748,  price=17250,  receip_id=1050, an_id=144},
        {name='snake',          value=viewer.getOptParamI("pet685.animal_234.owned",0),   ID=6750,  price=21500,  receip_id=1061, an_id=234},
        {name='squirrel',       value=viewer.getOptParamI("pet685.animal_145.owned",0),   ID=6752,  price=15300,  receip_id=1045, an_id=145},
        {name='swan',           value=viewer.getOptParamI("pet685.animal_235.owned",0),   ID=6754,  price=20650,  receip_id=1058, an_id=235},
        {name='turtle',         value=viewer.getOptParamI("pet685.animal_137.owned",0),   ID=6756,  price=20300,  receip_id=1056, an_id=137},
        {name='walrus',         value=viewer.getOptParamI("pet685.animal_236.owned",0),   ID=6758,  price=13000,  receip_id=1040, an_id=236},
        {name='wolf',           value=viewer.getOptParamI("pet685.animal_237.owned",0),   ID=6760,  price=25400,  receip_id=1065, an_id=237},
        {name='zebra',          value=viewer.getOptParamI("pet685.animal_142.owned",0),   ID=6762,  price=15650,  receip_id=1046, an_id=142},
        {name='rhinoceros',     value=viewer.getOptParamI("pet685.animal_524.owned",0),   ID=6764,  price=14500,  receip_id=1043, an_id=524},
        {name='robobird',       value=viewer.getOptParamI("pet685.animal_525.owned",0),   ID=6766,  price=7950,   receip_id=1034, an_id=525},
        {name='robodog',        value=viewer.getOptParamI("pet685.animal_526.owned",0),   ID=6768,  price=10400,  receip_id=1037, an_id=526},
        {name='robomonkey',     value=viewer.getOptParamI("pet685.animal_527.owned",0),   ID=6770,  price=8500,   receip_id=1035, an_id=527},
        {name='hare',           value=viewer.getOptParamI("pet685.animal_1071.owned",0),  ID=7888,  price=19600,  receip_id=1077, an_id=1071},
        {name='mouse',          value=viewer.getOptParamI("pet685.animal_1072.owned",0),  ID=7890,  price=15200,  receip_id=1078, an_id=1072},
        {name='crab',           value=viewer.getOptParamI("pet685.animal_1073.owned",0),  ID=7892,  price=19500,  receip_id=1079, an_id=1073},
        {name='whale',          value=viewer.getOptParamI("pet685.animal_1074.owned",0),  ID=7894,  price=16500,  receip_id=1080, an_id=1074},
        {name='robosaurus',     value=viewer.getOptParamI("pet685.animal_1075.owned",0),  ID=7896,  price=9850,   receip_id=1081, an_id=1075},
        {name='robolion',       value=viewer.getOptParamI("pet685.animal_1086.owned",0),  ID=9056,  price=50000,  receip_id=1331, an_id=1086},
        {name='robofrog',       value=viewer.getOptParamI("pet685.animal_1087.owned",0),  ID=9058,  price=26500,  receip_id=1332, an_id=1087},
        {name='robobear',       value=viewer.getOptParamI("pet685.animal_1088.owned",0),  ID=9060,  price=41500,  receip_id=1333, an_id=1088},
        {name='roboorca',       value=viewer.getOptParamI("pet685.animal_1089.owned",0),  ID=9062,  price=18500,  receip_id=1334, an_id=1089},
      }
       print(("размер таблицы: %d"):format(table_length(animals)))
    end
function table_length(t)
       local i=1
       while t[i]~=nil do
         i=i+1
       end  
       return(i-1)
end  
function obj_refresh_parse_info:state(state,guestID)
  	function write_public()
   		print ("Запись в паблик животных")
      for i=1,table_length(animals) do
          ParamName="public.animals."..animals[i].name
          viewer.setOptParamI(ParamName, animals[i].value,1)
      end
    end
    function get_table_public()
      for i=1,table_length(animals) do
          animals_public[i]={name=animals[i].name,value=viewer.getObjParamI(2292,"selected_public.animals."..animals[i].name,0),ID=animals[i].ID}
        end
      print("Таблица с данными из паблика сформирована")
    end
    function get_table_me()
      for i=1,table_length(animals) do
          animals_public[i]={name=animals[i].name,value=viewer.getOptParamI("public.animals."..animals[i].name,0,1),ID=animals[i].ID}
        end
      print("Таблица с данными из опций сформирована")
    end
    function table_sort ()
      table.sort(animals_public, function(a,b) return (a.value>b.value) end)
      print("Таблица с данными из паблика отсортирована по убыванию")
    end
    function set_parent()
      for i=1,table_length(animals_public) do
        viewer.changeObjState(animals_public[i].ID,"parent_tb")
        print("Добавлено животное: "..animals_public[i].name)
      end  
      viewer.changeObjState(4446,"reload")
    end
    function set_last_activ_time()
      default_date=viewer.getOptParamI("cur_time",0,0)
      date=viewer.getObjParamI(2292,"selected_public.fr_last_act",0)
      if (date==0) then
        date=default_date
      end
      date=os.date("%c",date)
      viewer.setObjParamS(6698,"date",date)
      viewer.changeObjState(6785,"init")
      print("Друг заходил в игру последний раз: "..date)
    end
    function set_last_activ_time_me()
        date=viewer.getOptParamI("cur_time",0,0)
        date=os.date("%c",date)
        viewer.setObjParamS(6698,"date",date)
        viewer.changeObjState(6785,"init")
        print("Друг заходил в игру последний раз: "..date)
    end
	if 	(state == "refresh") then
    get_table_animals ()
		write_public()
	end
  if 	(state == "set_parent") then
    get_table_public ()
    table_sort()	
    set_parent()
    set_last_activ_time()
	end
  if 	(state == "set_me") then
    get_table_me ()
    table_sort()	
    set_parent()
    set_last_activ_time_me()
	end
end

obj_root_anim_amulets = class()
function clear ()
    local table_active_amulets = {}
    local clone_list = {}
    viewer.setOptParamArrI("table_active_amulets",table_active_amulets,0)
    viewer.setOptParamArrI("amulets_clone_list",clone_list,0)
end  
function obj_root_anim_amulets:init()
    clear()
end
function obj_root_anim_amulets:state(state,guestID)
  	function check()
        local clown = viewer.getOptParamF("time_effect.clown",0,0)
        local elvis = viewer.getOptParamF("time_effect.elvis",0,0)
        local glass = viewer.getOptParamF("time_effect.glass",0,0)
        local kind2 = viewer.getOptParamF("time_effect.kind2",0,0)
        local dance = viewer.getOptParamF("time_effect.dance",0,0)
        local table_all_amulets = {{num=clown,id=611},{num=elvis,id=610},{num=glass,id=612},{num=kind2,id=614},{num=dance,id=617}}
        print ("table_all_amulets was formed")
    		local table_active_amulets = {}
        for i,v in pairs(table_all_amulets) do
          if (table_all_amulets[i].num>0) then
            table.insert(table_active_amulets,table_all_amulets[i].id)
            print("add amulet with id: "..table_all_amulets[i].id)
          end
        end
        print ("table_active_amulets was formed")
        viewer.setOptParamArrI("table_active_amulets",table_active_amulets,0)
        for i,v in pairs(table_active_amulets) do
          viewer.changeObjState(9040,"clone")
          print("clone created")
        end  
  	end
  	function clone_reg ()
        local clone_id = viewer.getObjParamI(6664,"clone_id",9040)
        local clone_list = {}
        clone_list = viewer.getOptParamArrI("amulets_clone_list",0)
        table.insert(clone_list,clone_id)
        viewer.setOptParamArrI("amulets_clone_list",clone_list,0)
        print("clone registr done")
    end
    function show()
        local clone_list = {}
        clone_list = viewer.getOptParamArrI("amulets_clone_list",0)
        local table_active_amulets = {}
        table_active_amulets = viewer.getOptParamArrI("table_active_amulets",0)
        local dy = 0
        for i,v in pairs(table_active_amulets) do
            local res = viewer.getResFromTxtDB(table_active_amulets[i],1,2708)
            viewer.setObjParamI(clone_list[i]+1,"res",res)
            local y = -170
            viewer.setObjParamI(clone_list[i],"y", y + dy)
            dy = dy + 100
            viewer.changeObjState(clone_list[i]+1,"init")
            viewer.changeObjState(clone_list[i],"vis")
        end  
    end  
	if 	(state == "check") then
		check()
	end
  if 	(state == "clone_reg") then
		clone_reg()
	end
  if 	(state == "show") then
		show()
	end
  if 	(state == "clear") then
		clear()
	end
end

obj_root_bridge = class()
function obj_root_bridge:state(state,guestID)
    function game_start()
        print ("state game_start called")
        self.start_t=os.time()
    end
    function game_end()
        self.end_t=os.time()
        viewer.setObjParamI(6664,"bridge_time_spent",self.end_t-self.start_t)
    end
    if 	(state == "start_level") then
        game_start()
    end
    if 	(state == "apply") then
        game_end()
    end
end

obj_root_cake = class()
function obj_root_cake:state(state,guestID)
 function game_start()
    		print ("state game_start called")
        self.start_t=os.time()
  	end
    function game_end()
        self.end_t=os.time()
        viewer.setObjParamI(6664,"cake_time_spent",self.end_t-self.start_t)
    end
 	if 	(state == "start_level") then
		game_start()
	end
  if 	(state == "apply") then
		game_end()
	end
end

obj_root_cube = class()
function obj_root_cube:state(state,guestID)
    function game_start()
        print ("state game_start called")
        self.start_t=os.time()
    end
    function game_end()
        self.end_t=os.time()
        viewer.setObjParamI(6664,"cube_time_spent",self.end_t-self.start_t)
    end
    if 	(state == "start_level") then
        game_start()
    end
    if 	(state == "apply") then
        game_end()
    end
end

obj_root_flappy = class()
function obj_root_flappy:state(state,guestID)
  	function game_start()
    		print ("state game_start called")
        self.start_t=os.time()
  	end
    function game_end()
        self.end_t=os.time()
        viewer.setObjParamI(6664,"flappy_time_spent",self.end_t-self.start_t)
    end
 	if 	(state == "start_level") then
		game_start()
	end
  if 	(state == "apply") then
		game_end()
	end
end

obj_root_four = class()
function obj_root_four:state(state,guestID)
    function game_start()
        print ("state game_start called")
        self.start_t=os.time()
    end
    function game_end()
        self.end_t=os.time()
        viewer.setObjParamI(6664,"four_time_spent",self.end_t-self.start_t)
    end
    if 	(state == "start_level") then
        game_start()
    end
    if 	(state == "apply") then
        game_end()
    end
end

obj_root_gift_for_purchase = class()
function obj_root_gift_for_purchase:init()
  self.all_gifts = {617,610,612,616,613,614,609}
end
function obj_root_gift_for_purchase:state(state,guestID)
  	function gift1()
    		self.num = 1
        give()
  	end
    function gift2()
    		self.num = 2
        give()
  	end
    function gift3()
    		self.num = 3
        give()
  	end
    function give()
        viewer.tableClear(9096)
        local gifts = {}
        local temp_all_gifts = {}
        for i=1,#self.all_gifts do
            temp_all_gifts[i] = self.all_gifts[i]
        end  
        for i=1,self.num do
            rnd = math.random(#temp_all_gifts)
            local item = temp_all_gifts[rnd]
            table.insert(gifts,item)
            table.remove(temp_all_gifts,rnd)
        end
        for i=1,#gifts do
            local item = gifts[i]
            local img = viewer.getResFromTxtDB(item,1,2706)
            viewer.setObjParamI(9098+i,"res",img)
            viewer.changeObjState(9098+i,"init")
            viewer.tableAddCellObj(9096,9098+i,i-1,0)
            viewer.setObjParamI(1154,"param",item)
            viewer.changeObjState(1154,"add_param")
        end
        viewer.changeObjState(9089,"open")
    end    
  	
	if 	(state == "1") then
		gift1()
	end
  if 	(state == "2") then
		gift2()
	end
  if 	(state == "3") then
		gift3()
	end
end

obj_root_parabola = class()
function obj_root_parabola:state(state,guestID)
    function game_start()
        print ("state game_start called")
        self.start_t=os.time()
    end
    function game_end()
        self.end_t=os.time()
        viewer.setObjParamI(6664,"parabola_time_spent",self.end_t-self.start_t)
    end
    if 	(state == "start_level") then
        game_start()
    end
    if 	(state == "apply") then
        game_end()
    end
end

obj_root_pentamino = class()
function obj_root_pentamino:state(state,guestID)
  	function game_start()
    		print ("state game_start called")
        self.start_t=os.time()
  	end
    function game_end()
        self.end_t=os.time()
        viewer.setObjParamI(6664,"pentamino_time_spent",self.end_t-self.start_t)
    end
 	if 	(state == "start_level") then
		game_start()
	end
  if 	(state == "apply") then
		game_end()
	end
end

obj_root_planets = class()
function obj_root_planets:timer(dt)
function game_start()
    		print ("state game_start called")
        self.start_t=os.time()
  	end
function game_end()
        self.end_t=os.time()
        viewer.setObjParamI(6664,"planets_time_spent",self.end_t-self.start_t)
end
 	if 	(state == "start_level") then
		game_start()
	end
  if 	(state == "apply") then
		game_end()
	end
end

obj_root_tap = class()
function obj_root_tap:state(state,guestID)
  	function start()
    		print ("state game_start called")
        self.start_t=os.time()
  	end
    function game_end()
        self.end_t=os.time()
        viewer.setObjParamI(6664,"tap_the_bubble_time_spent",self.end_t-self.start_t)
    end
 	if 	(state == "start") then
		start()
	end
  if 	(state == "apply") then
		game_end()
	end
end

obj_root_vertical = class()
function obj_root_vertical:state(state,guestID)
    function game_start()
        print ("state game_start called")
        self.start_t=os.time()
    end
    function game_end()
        self.end_t=os.time()
        viewer.setObjParamI(6664,"vertical_time_spent",self.end_t-self.start_t)
    end
    if 	(state == "start_level") then
        game_start()
    end
    if 	(state == "apply") then
        game_end()
        end
end

function times(time,str_w,str_d,str_h,str_m,str_s,num)
  local week=604800 -- секунд в неделе
  local day=86400 -- секунд в сутках
  local hour=3600 -- секунд в часе
  local min=60 -- секунд в минуте
  print ("time "..time)     
  local time_w = math.floor(time/week) -- получаем целое число недель
  local time_d = math.floor((time-(time_w*week))/day) -- получаем целое число дней
  local time_h = math.floor((time-(time_w*week+time_d*day))/hour) -- получаем целое число часов
  local time_m = math.floor((time-(time_w*week+time_d*day+time_h*hour))/min) -- получаем целое число минут
  local time_s = time - (time_w*week+time_d*day+time_h*hour+time_m*min) -- получаем целое число секунд (остаток)
  local max_show = num
  str="" -- формируем строку с учетом нулевых единиц времени
  print ("time_w"..time_w)
  print ("time_d"..time_d)
  print ("time_h"..time_h)
  print ("time_m"..time_m)
  if (time_w>0 and (max_show>0 or num == 0)) then
    str=str..time_w..str_w.." "
    max_show = max_show - 1
  end
  if (time_d>0 and (max_show>0 or num == 0)) then
    str=str..time_d..str_d.." "
    max_show = max_show - 1
  end
  if (time_h>0 and (max_show>0 or num == 0)) then
    str=str..time_h..str_h.." "
    max_show = max_show - 1
  end
  if (time_m>0 and (max_show>0 or num == 0)) then
    str=str..time_m..str_m.." "
    max_show = max_show - 1
  end
 print(str)
 return str
end  
obj_set_timers = class()
function obj_set_timers:state(state,guestID)
  	function set_time()
    		local id_sc = viewer.getObjParamI(guestID,"sales_scenario",0)
        local timer_id = viewer.getObjParamI(7396,"timer",0)
        local level = "salesmanager2694"..".ev"..id_sc..".tl"
        local time = viewer.getOptParamI(level,"0",1)
        print ("timer level: "..level)
        local w = viewer.getStrFromTxtDB(1261,0,"w")
        local d = viewer.getStrFromTxtDB(1258,0,"d")
        local h = viewer.getStrFromTxtDB(1259,0,"h")
        local m = viewer.getStrFromTxtDB(1260,0,"m")
        local s = viewer.getStrFromTxtDB(1262,0,"s")
        local text = times(time,w,d,h,m,s,0)
        viewer.setObjParamI(timer_id,"val",time*1000)
        viewer.setObjParamI(timer_id,"time_second",time)
        viewer.setObjParamS(timer_id,"txt",text)
        viewer.changeObjState(timer_id,"init")
        viewer.changeObjState(timer_id,"run")
  	end
  	
	if 	(state == "set") then
		set_time()
    print("state set run")
	end
end

obj_share_animals = class()
function obj_share_animals:state(state,guestID)
  	function check_share()
    		local animal = viewer.getObjParamI(1614,"txtID",0)
        local shared = viewer.getOptParamI("pet685.animal_"..animal..".shared",0,1)
        if (shared == 0) then
          viewer.setObjParamS(6664,"need_show",1)
        else 
        viewer.setObjParamS(6664,"need_show",0)
        end  
  	end
    function shared()
        local animal = viewer.getObjParamI(1614,"txtID",0)
        local shared = viewer.getOptParamI("pet685.animal_"..animal..".shared",0,1)
        if (shared == 0) then
              viewer.changeObjState(9145,"move")
        end  
        viewer.setOptParamI("pet685.animal_"..animal..".shared",1,1)
    end  
  	
	if 	(state == "check_share") then
		check_share()
	end
  if 	(state == "shared") then
		shared()
	end
end

obj_views_count = class()
function obj_views_count:state(state,guestID)
  	function count()
    		local id_scenario = viewer.getObjParamI(2694,"param",0)
        local count_scenario = viewer.getOptParamI("stat.actions_views.id"..id_scenario..".views",0,0)
        count_scenario = count_scenario + 1
        viewer.setOptParamI("stat.actions_views.id"..id_scenario..".views",count_scenario,0)
        viewer.setObjParamI(6664,"action_views",count_scenario)
  	end
  	
	if 	(state == "count") then
		count()
	end
end

obj_VIP_indicate = class()
function obj_VIP_indicate:state(state,guestID)
  	function set_time()
    		local time1 = viewer.getOptParamS("ecomics6.ittimes.itm389",0,1)
        local time2 = viewer.getOptParamS("ecomics6.ittimes.itm390",0,1)
        local time = math.max(time1,time2)
        time = time/1000
        local w = viewer.getStrFromTxtDB(1261,0,"w")
        local d = viewer.getStrFromTxtDB(1258,0,"d")
        local h = viewer.getStrFromTxtDB(1259,0,"h")
        local m = viewer.getStrFromTxtDB(1260,0,"m")
        local s = viewer.getStrFromTxtDB(1262,0,"s")
        local text = times(time,w,d,h,m,s,2)
        text = "VIP: "..text
        viewer.setObjParamS(8672,"txt",text)
        viewer.changeObjState(8672,"init")
  	end
  	
	if 	(state == "check") then
		set_time()
	end
end

obj_win_count_screen = class()
function obj_win_count_screen:state(state,guestID)
  	function check()
    		screen = viewer.getOptParamI("curScrID",0,0)
        win_count = viewer.getOptParamI("screens.s"..screen..".win_count",0,1)
        if (win_count == 0) then 
          viewer.setOptParamI("big_win_num",2,0)
        else 
        viewer.setOptParamI("big_win_num",3,0)
        end
  	end
    function set()
        viewer.setOptParamI("screens.s"..screen..".win_count",win_count+1,1)
  	end
	if 	(state == "check") then
		check()
	end
  if 	(state == "set") then
		set()
	end
end

obj_wish_statistic = class()
function obj_wish_statistic:state(state,guestID)
  	function add()
    	local colWishList = {}
        colWishList = viewer.getOptParamArrI("public.colWishList",1)
        print("colWishList size "..#colWishList)
        local wishitem = colWishList[#colWishList]
        print ("wishitem "..tostring(wishitem))
        viewer.setObjParamI(6664,"wishitem",wishitem)
    end
    function share()
        local colWishList = {}
        colWishList = viewer.getOptParamArrI("public.colWishList",1)
        viewer.setObjParamI(6664,"wish_items_quantity",#colWishList)
    end
	if 	(state == "add") then
		add()
    end
    if 	(state == "share") then
        share()
    end
end

tcontrol = class()
function tcontrol:init()
    self.tstate = viewer.getOptParamS("tutorial_state", "empty", 0)
end
function tcontrol:state(state,guestID)
    function tutorial1()
        viewer.setObjParamS(10767, "txtID", 1609)
        viewer.changeObjState(10767, "init")
    end
    function tutorial2()
        viewer.setObjParamS(10767, "txtID", 1610)
        viewer.changeObjState(10767, "init")
        self.tstate = "completed"
        viewer.setOptParamS("tutorial_state", "completed", 0)
    end
    function tutorial3()
        viewer.setObjParamS(10767, "txt", "Show a precision!")
        viewer.changeObjState(10767, "init")
        self.tstate = "completed"
        viewer.setOptParamS("tutorial_state", "completed", 0)
    end
    function completed()
        viewer.setObjParamS(10767, "al", 0)
        viewer.changeObjState(10767, "init")
    end
    function helper()
        if (state == "tutorial1")
        then tutorial1()
        elseif (state == "tutorial2")
        then tutorial2()
        elseif (state == "tutorial3")
        then tutorial3()
        end
    end
    if (self.tstate == "empty")
    then helper()
    else
        completed()
    end
end

tcontrol_parabola = class()
function tcontrol_parabola:init()
    self.tstate_parabola = viewer.getOptParamS("tutorial_state_parabola", "empty", 0)
end
function tcontrol_parabola:state(state,guestID)
    function tutorial1()
        viewer.setObjParamS(10710, "txtID", 1607)
        viewer.changeObjState(10710, "init")
    end
    function tutorial2()
        viewer.setObjParamS(10710, "txtID", 1608)
        viewer.changeObjState(10710, "init")
        self.tstate_parabola = "completed"
        viewer.setOptParamS("tutorial_state_parabola", "completed", 0)
    end
    function tutorial3()
        viewer.setObjParamS(10710, "txt", "Use the spring power")
        viewer.changeObjState(10710, "init")
        self.tstate_parabola = "completed"
        viewer.setOptParamS("tutorial_state_parabola", "completed", 0)
    end
    function completed()
        viewer.setObjParamS(10710, "al", 0)
        viewer.changeObjState(10710, "init")
    end
    function helper()
        if (state == "tutorial1")
        then tutorial1()
        elseif (state == "tutorial2")
        then tutorial2()
        elseif (state == "tutorial3")
        then tutorial3()
        end
    end
    if (self.tstate_parabola == "empty")
    then helper()
    else
        completed()
    end
end

